﻿using System;
using System.Web.UI;
using ThinkGeo.MapSuite.Core;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.WebEdition;

public partial class _Default : System.Web.UI.Page, ICallbackEventHandler
{
    private string callbackResult = string.Empty;
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#B3C6D4"));
            Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
            Map1.MapUnit = GeographyUnit.DecimalDegree;

            ShapeFileFeatureLayer statesLayer = new ShapeFileFeatureLayer(MapPath("~/App_Data/states.shp"));
            statesLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.FromArgb(255, 243, 239, 228), GeoColor.FromArgb(255, 218, 193, 163), 1);
            statesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            Map1.StaticOverlay.Layers.Add("StaticLayer", statesLayer);

            string version = Map.Version;
        }
    }

    #region ICallbackEventHandler Members

    public string GetCallbackResult()
    {
        return callbackResult;
    }

    public void RaiseCallbackEvent(string eventArgument)
    {
        string[] lonlatStrings = eventArgument.Split(',');
        PointShape lonlat = new PointShape(double.Parse(lonlatStrings[0]), double.Parse(lonlatStrings[1]));
        ShapeFileFeatureLayer statesLayer = (ShapeFileFeatureLayer)Map1.StaticOverlay.Layers["StaticLayer"];
        statesLayer.Open();

        // in your senario, you can loop through all the layers, 
        // find the features which you needed,
        // send the result back to client.
        Collection<Feature> features = statesLayer.QueryTools.GetFeaturesContaining(lonlat, ReturningColumnsType.AllColumns);

        if (features.Count > 0)
        {
            callbackResult = features[0].ColumnValues["STATE_NAME"];
        }
    }

    #endregion
}
